#!/bin/bash

docker run --rm \
    -e DRONE_COMMIT_REF=refs/heads/trunk \
    -e DRONE_REPO_BRANCH=trunk \
	-e PLUGIN_REGISTRY=git.vdhsn.com \
    -e PLUGIN_REPO=git.vdhsn.com/barretthousen/service-catalog \
    -e PLUGIN_BUILD_ARGS="service=catalog" \
    -e PLUGIN_TAGS=$(git rev-parse --verify --short HEAD) \
	-e PLUGIN_CONTEXT="./src" \
	-e PLUGIN_DOCKERFILE="./src/Dockerfile.prod-backend" \
	-e PLUGIN_USERNAME=${DOCKER_USERNAME} \
    -e PLUGIN_PASSWORD=${DOCKER_PASSWORD} \
	-e PLUGIN_ENABLE_CACHE=true \
	-e PLUGIN_CACHE_REPO='git.vdhsn.com/barretthousen/ci-cache' \
	-e PLUGIN_SKIP_UNUSED_STAGES=true \
    -v $(pwd):/drone \
    -w /drone \
    plugins/kaniko:linux-amd64
